/*
 * Programming in Java, Jacobs University, 2015
 *
 * Create a frame (a top-level window) and add a buttons to it that
 * change the color if pressed.
 *
 * This version uses inner classes and anonymous inner classes to
 * implement the listener interfaces.
 */ 

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.awt.event.WindowAdapter;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JButton;

public class ButtonPanel extends JPanel
{
    public ButtonPanel()
    {
	JButton yellowButton = new JButton("Yellow");
	JButton blueButton = new JButton("Blue");
	JButton redButton = new JButton("Red");

	add(yellowButton);
	add(blueButton);
	add(redButton);

	ColorAction yellowAction = new ColorAction(this, Color.YELLOW);
	ColorAction blueAction = new ColorAction(this, Color.BLUE);
	ColorAction redAction = new ColorAction(this, Color.RED);

	yellowButton.addActionListener(yellowAction);
	blueButton.addActionListener(blueAction);
	redButton.addActionListener(redAction);
    }

    class ColorAction implements ActionListener
    {
	private JPanel panel;
	private Color color;
	
	public ColorAction(JPanel panel, Color color)
	{
	    this.panel = panel;
	    this.color = color;
	}

	public void actionPerformed(ActionEvent e)
	{
	    panel.setBackground(color);
	}
    }

    public static void main(String[] args)
    {
	JFrame frame = new JFrame();
	frame.add(new ButtonPanel());
	frame.pack();
	frame.addWindowListener(new WindowAdapter() {
		@Override
		public void windowClosing(WindowEvent e) {
		    System.exit(0);
		}
	    });
	frame.setVisible(true);
    }
}
